## ros-noetic-hri 0.6.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(hri)

## ROS noetic officially supports c++14
add_compile_options(-std=c++14)

find_package(catkin REQUIRED COMPONENTS
  geometry_msgs
  hri_msgs
  sensor_msgs
  rosconsole
  roscpp
  std_msgs
  tf2
  tf2_ros
  cv_bridge
)

find_package(OpenCV REQUIRED)
find_package(Boost REQUIRED) # for boost::optional

include_directories(
    SYSTEM
    ${OpenCV_INCLUDE_DIRS}
    ${Boost_INCLUDE_DIRS}
    ${catkin_INCLUDE_DIRS}
)

include_directories(
    include
)

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES hri
  CATKIN_DEPENDS geometry_msgs hri_msgs rosconsole roscpp std_msgs tf2 cv_bridge
)

add_library(${PROJECT_NAME}
  src/hri.cpp
  src/body.cpp
  src/face.cpp
  src/person.cpp
  src/voice.cpp
)

target_link_libraries(${PROJECT_NAME} ${catkin_LIBRARIES})
add_dependencies(${PROJECT_NAME} ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})

if(BUILD_EXAMPLES)
add_executable(show_faces_example
    examples/show_faces.cpp
)
target_link_libraries(show_faces_example ${PROJECT_NAME} ${catkin_LIBRARIES})

endif()

###########################################################
# Tests

if(CATKIN_ENABLE_TESTING)

find_package(rostest REQUIRED)

add_rostest_gmock(test_hri test/test_hri.test test/test_hri.cpp)
target_include_directories(test_hri PRIVATE ${rostest_INCLUDE_DIRS})
target_link_libraries(test_hri ${PROJECT_NAME})

endif() # CATKIN_ENABLE_TESTING


###########################################################
# Install

install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
  PATTERN ".svn" EXCLUDE
)

=== debian/changelog ===
ros-noetic-hri (0.6.0-1buster) buster; urgency=high

  * redefine hri::FeatureType enum to be used as bitmask
  * Contributors: Séverin Lemaignan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Wed, 04 Jan 2023 23:00:00 -0000

ros-noetic-hri (0.5.3-1buster) buster; urgency=high

  * bodies: expose the skeleton2d points
  * package.xml: add libhri URL
  * Contributors: Séverin Lemaignan, lorenzoferrini

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Tue, 25 Oct 2022 22:00:00 -0000

ros-noetic-hri (0.5.2-1buster) buster; urgency=high

  * expose the 3D transform of the voices
  * expose face + gaze transform
  * expose the 3D transform of the bodies
  * minor refactor for safer access to engagement_status
  * Contributors: Séverin Lemaignan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Sun, 09 Oct 2022 22:00:00 -0000

ros-noetic-hri (0.5.1-1buster) buster; urgency=high

  * add comparision between 'feature trackers'
  * update to new hri_msgs-0.8.0 names
  * Contributors: Séverin Lemaignan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Tue, 30 Aug 2022 22:00:00 -0000

ros-noetic-hri (0.5.0-1buster) buster; urgency=high

  * expose the current TF frame + transform of the person
  * expose engagement status of people
  * expose softbiometrics (age/gender) in faces
  * add support for persons' aliases
    if a /humans/persons/<id>/alias points to another person id, libhri will use
    return the same pointer
  * add callbacks when face/body/... are lost + support for known vs tracked persons
  * add support for 'anonymous' persons
    Anonymous persons are persons that *may* disappear at any point.
    They are typically created because we *know* that a person is there (eg,
    we've detected a face), but that person is not yet permanently
    identified.
    API change: HriListener::getPersons() now returns *weak* pointers that
    need to be locked before being used.
  * ensure the cropped and aligned face do not re-use the same underlying data
  * add simple libhri example to display aligned faces
  * remove spurious logging on cout
  * Contributors: Séverin Lemaignan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Wed, 25 May 2022 22:00:00 -0000

ros-noetic-hri (0.4.3-1buster) buster; urgency=high

  * fix gmock 'Call' syntax for older version of gmock (1.8). This was causing
    issues on ubuntu 18.04 (ROS melodic)
  * Contributors: Séverin Lemaignan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Wed, 27 Apr 2022 22:00:00 -0000

ros-noetic-hri (0.4.2-1buster) buster; urgency=high

  * add callback support for faces, bodies, voices, persons.
    Eg, call onFace(cb) to register callback invoked everytime a face is detected
  * expose the aligned face in the Face class
  * Contributors: Séverin Lemaignan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Tue, 26 Apr 2022 22:00:00 -0000

ros-noetic-hri (0.4.1-1buster) buster; urgency=high

  * Fixed wrong feature subscribers indexing
  * Contributors: lorenzoferrini

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Sun, 06 Mar 2022 23:00:00 -0000

ros-noetic-hri (0.4.0-1buster) buster; urgency=high

  * Facial Landmarks implementation
    Implementation of methods and structures required to access the
    facial landmarks
    Face Landmarks object size correction
  * add tests for the person.face_id attribute
  * actually subscribe to the person's face/body/voice id updates
  * Contributors: Séverin Lemaignan, lorenzoferrini

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Sun, 20 Feb 2022 23:00:00 -0000

ros-noetic-hri (0.3.1-1buster) buster; urgency=high

  * add/update BSD license
  * Contributors: Séverin Lemaignan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Sun, 06 Feb 2022 23:00:00 -0000

ros-noetic-hri (0.3.0-1buster) buster; urgency=high

  * expose enum with the 4 feature types person,face,body,voice
  * add voices and persons + improve const semantics
  * Contributors: Séverin Lemaignan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Sun, 06 Feb 2022 23:00:00 -0000

ros-noetic-hri (0.2.3-1buster) buster; urgency=high

  * Body::{getRoI->roi} + RoI not optional + add Body::cropped
  * Contributors: Séverin Lemaignan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Thu, 20 Jan 2022 23:00:00 -0000

ros-noetic-hri (0.2.2-1buster) buster; urgency=high

  * Face::{getRoI->roi} + RoI not optional + add Face::cropped
    In the latest revision of the ROS4HRI spec, the region of interest is
    always expected to be available (as well as the cropped face). As such,
    no point in using a boost::optional there.
  * Contributors: Séverin Lemaignan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Thu, 20 Jan 2022 23:00:00 -0000

ros-noetic-hri (0.2.1-1buster) buster; urgency=high

  * replace hri_msgs::RegionOfInterestStamped by sensor_msgs::RegionOfInterest
    Follows changes in hri_msgs 0.2.0
  * add skeleton of hri::Person class
  * add empty Voice class
  * expose the features' topic namespace + doc
  * Contributors: Séverin Lemaignan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Thu, 13 Jan 2022 23:00:00 -0000

ros-noetic-hri (0.2.0-1buster) buster; urgency=high

  * add basic support for bodies; only the RoIs for now
  * Contributors: Séverin Lemaignan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Tue, 04 Jan 2022 23:00:00 -0000

ros-noetic-hri (0.1.0-1buster) buster; urgency=high

  * use boost::optional for faces' features like RoI
  * doc: setup rosdoc. Run rosdoc_lite . to generate
  * test: expand the test suite
  * cmake: explicit SYSTEM headers to avoid ROS shadowing issues
  * Contributors: Séverin Lemaignan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Tue, 04 Jan 2022 23:00:00 -0000

ros-noetic-hri (0.0.3-1buster) buster; urgency=high

  * do not try to compile hri_demo (internal test)


=== debian/control ===
Source: ros-noetic-hri
Section: misc
Priority: optional
Maintainer: Séverin Lemaignan <severin.lemaignan@pal-robotics.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, ros-noetic-catkin, ros-noetic-cv-bridge, ros-noetic-geometry-msgs, ros-noetic-hri-msgs, ros-noetic-rosconsole, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-tf2, ros-noetic-tf2-ros
Homepage: http://wiki.ros.org/hri
Standards-Version: 3.9.2

Package: ros-noetic-hri
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-cv-bridge, ros-noetic-geometry-msgs, ros-noetic-hri-msgs, ros-noetic-rosconsole, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-tf2, ros-noetic-tf2-ros
Description: A wrapper library around the ROS4HRI ROS topics

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-hri//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install

## ros-noetic-hri 0.6.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,7 @@
 
 find_package(catkin REQUIRED COMPONENTS
   geometry_msgs
+  std_msgs
   hri_msgs
   sensor_msgs
   rosconsole

=== debian/changelog ===
ros-noetic-hri (0.6.4-1focal) focal; urgency=high

  * Fix Typo in voice.h
    re-apply patch from  juandpenan
    https://github.com/ros4hri/libhri/pull/3
    (patch removed by mistake)
  * Contributors: juandpenan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Tue, 04 Jul 2023 22:00:00 -0000

ros-noetic-hri (0.6.3-1focal) focal; urgency=high

  * change ROI message type to hri_msgs/NormalizedRegionOfInterest2D
  * fix tests use of EXPECT_CALL and timeouts
  * Contributors: Luka Juricic

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Tue, 04 Jul 2023 22:00:00 -0000

ros-noetic-hri (0.6.2-1focal) focal; urgency=high

  * anonymous field as optional
  * Contributors: lorenzoferrini

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Thu, 20 Apr 2023 22:00:00 -0000

ros-noetic-hri (0.6.1-1focal) focal; urgency=high

  * add callbacks for when speech is detected on a voice
  * Contributors: Séverin Lemaignan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Sun, 15 Jan 2023 23:00:00 -0000

ros-noetic-hri (0.6.0-1focal) focal; urgency=high

  * redefine hri::FeatureType enum to be used as bitmask
  * Contributors: Séverin Lemaignan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Wed, 04 Jan 2023 23:00:00 -0000

ros-noetic-hri (0.5.3-1focal) focal; urgency=high

  * bodies: expose the skeleton2d points
  * package.xml: add libhri URL
  * Contributors: Séverin Lemaignan, lorenzoferrini

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Tue, 25 Oct 2022 22:00:00 -0000

ros-noetic-hri (0.5.2-1focal) focal; urgency=high

  * expose the 3D transform of the voices
  * expose face + gaze transform
  * expose the 3D transform of the bodies
  * minor refactor for safer access to engagement_status
  * Contributors: Séverin Lemaignan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Sun, 09 Oct 2022 22:00:00 -0000

ros-noetic-hri (0.5.1-1focal) focal; urgency=high

  * add comparision between 'feature trackers'
  * update to new hri_msgs-0.8.0 names
  * Contributors: Séverin Lemaignan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Tue, 30 Aug 2022 22:00:00 -0000

ros-noetic-hri (0.5.0-1focal) focal; urgency=high

  * expose the current TF frame + transform of the person
  * expose engagement status of people
  * expose softbiometrics (age/gender) in faces
  * add support for persons' aliases
    if a /humans/persons/<id>/alias points to another person id, libhri will use
    return the same pointer
  * add callbacks when face/body/... are lost + support for known vs tracked persons
  * add support for 'anonymous' persons
    Anonymous persons are persons that *may* disappear at any point.
    They are typically created because we *know* that a person is there (eg,
    we've detected a face), but that person is not yet permanently
    identified.
    API change: HriListener::getPersons() now returns *weak* pointers that
    need to be locked before being used.
  * ensure the cropped and aligned face do not re-use the same underlying data
  * add simple libhri example to display aligned faces
  * remove spurious logging on cout
  * Contributors: Séverin Lemaignan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Wed, 25 May 2022 22:00:00 -0000

ros-noetic-hri (0.4.3-1focal) focal; urgency=high

  * fix gmock 'Call' syntax for older version of gmock (1.8). This was causing
    issues on ubuntu 18.04 (ROS melodic)
  * Contributors: Séverin Lemaignan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Wed, 27 Apr 2022 22:00:00 -0000

ros-noetic-hri (0.4.2-1focal) focal; urgency=high

  * add callback support for faces, bodies, voices, persons.
    Eg, call onFace(cb) to register callback invoked everytime a face is detected
  * expose the aligned face in the Face class
  * Contributors: Séverin Lemaignan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Tue, 26 Apr 2022 22:00:00 -0000

ros-noetic-hri (0.4.1-1focal) focal; urgency=high

  * Fixed wrong feature subscribers indexing
  * Contributors: lorenzoferrini

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Sun, 06 Mar 2022 23:00:00 -0000

ros-noetic-hri (0.4.0-1focal) focal; urgency=high

  * Facial Landmarks implementation
    Implementation of methods and structures required to access the
    facial landmarks
    Face Landmarks object size correction
  * add tests for the person.face_id attribute
  * actually subscribe to the person's face/body/voice id updates
  * Contributors: Séverin Lemaignan, lorenzoferrini

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Sun, 20 Feb 2022 23:00:00 -0000

ros-noetic-hri (0.3.1-1focal) focal; urgency=high

  * add/update BSD license
  * Contributors: Séverin Lemaignan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Sun, 06 Feb 2022 23:00:00 -0000

ros-noetic-hri (0.3.0-1focal) focal; urgency=high

  * expose enum with the 4 feature types person,face,body,voice
  * add voices and persons + improve const semantics
  * Contributors: Séverin Lemaignan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Sun, 06 Feb 2022 23:00:00 -0000

ros-noetic-hri (0.2.3-1focal) focal; urgency=high

  * Body::{getRoI->roi} + RoI not optional + add Body::cropped
  * Contributors: Séverin Lemaignan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Thu, 20 Jan 2022 23:00:00 -0000

ros-noetic-hri (0.2.2-1focal) focal; urgency=high

  * Face::{getRoI->roi} + RoI not optional + add Face::cropped
    In the latest revision of the ROS4HRI spec, the region of interest is
    always expected to be available (as well as the cropped face). As such,
    no point in using a boost::optional there.
  * Contributors: Séverin Lemaignan

 -- Séverin Lemaignan <severin.lemaignan@pal-robotics.com>  Thu, 20 Jan 2022 23:00:00 -0000

ros-noetic-hri (0.2.1-1focal) focal; urgency=high

  * replace hri_msgs::RegionOfInterestStamped by sensor_msgs::RegionOfInterest
